package game.general
{
	import net.flashpunk.Entity;
	import net.flashpunk.Graphic;
	import net.flashpunk.Mask;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	
	public class ClickableText extends Entity
	{
		public var normalColor:uint = 0;
		public var highlightedColor:uint = 0x5E0DAC;
		public var clickedColor:uint = 0x8D41D6;
		
		public var textField:Text;
		
		protected var _hovering:Boolean;
		protected var _mouseDown:Boolean;
		protected var onClick:Function;
		
		public function ClickableText(text:String, onClick:Function, x:Number=0, y:Number=0)
		{
			super(x, y);
			
			this.onClick = onClick;
			
			textField = new Text(text);
			//textField.align = "center";
			textField.size = 16;
			textField.outlineColor = 0;
			textField.outlineStrength = 4;
			
			graphic = textField;
			
			_hovering = false;
			_mouseDown = false;
			
			updateHitbox();
		}
		
		/*
		public function centerX():void
		{
			textField.x = -textField.width / 2;
			updateHitbox();
		}
		*/
		
		public function updateHitbox():void
		{
			setHitbox(textField.width, textField.height, -textField.x, -textField.y);
		}
		
		override public function update():void
		{
			if (collidePoint(x, y, Input.mouseX, Input.mouseY))
			{
				if (Input.mousePressed)
				{
					mouseDown = true;
				}
				else if (Input.mouseReleased)
				{
					if (mouseDown)
					{
						if (onClick != null)
							onClick(this);
					}
					mouseDown = false;
				}
				hovering = true;
			}
			else
			{
				hovering = false;
				if (Input.mouseReleased)
				{
					mouseDown = false;
				}
			}
			
			updateColor();
		}
		
		protected function get hovering():Boolean { return _hovering; }
		protected function set hovering(value:Boolean):void
		{
			if (_hovering == value)
				return;
			
			_hovering = value;
			updateColor();
		}
		
		protected function get mouseDown():Boolean { return _mouseDown; }
		protected function set mouseDown(value:Boolean):void
		{
			if (_mouseDown == value)
				return;
			
			_mouseDown = value;
			updateColor();
		}

		public function updateColor():void
		{
			if (mouseDown)
			{
				textField.outlineColor = clickedColor;
			}
			else if (hovering)
			{
				textField.outlineColor = highlightedColor;
			}
			else
			{
				textField.outlineColor = normalColor;
			}
		}
	}
}