package game.states.play
{
	import flash.utils.Dictionary;
	
	import game.playState.PlayState;
	import game.states.play.data.LevelChunk;

	public class LevelManager
	{
		protected var playState:PlayState;
		protected var chunks:Dictionary;
		
		public function LevelManager(playState:PlayState, rawLevelData:XML)
		{
			this.playState = playState;
			
			analyzeChunkData(rawLevelData);
		}
		
		protected function analyzeChunkData(rawChunksData:XML):void
		{
			chunks = new Dictionary();
			
			for each (var chunkData:XML in rawChunksData.chunk)
			{
				var difficulty:Number = ("@difficulty" in chunkData) ? chunkData.@difficulty : 1;
				
				var chunk:LevelChunk = new LevelChunk(chunkData, difficulty);
				
				if (!(difficulty in chunks))
				{
					chunks[difficulty] = new Vector.<LevelChunk>();
				}
				
				chunks[difficulty].push(chunk);
			}
		}
		
		protected function loadFirstLevel():void
		{
			loadLevel(chunks[0][0]);
		}
		
		protected function loadLevel(chunk:LevelChunk):void
		{
			chunk.create(playState);
		}
		
		public function update():void
		{
		}
	}
}