package game.playState
{
	import game.Assets;
	import game.Constants;
	
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.TiledImage;
	
	public class PlayField extends PlaystateEntity {
		
		protected var tilesImage:TiledImage;
		protected var tilesImageCountX:int;
		
		public function PlayField(playState:PlayState) {
			super(playState);
			
			tilesImage = new TiledImage(Assets.TILES, Assets.TILES_WIDTH, Assets.TILES_HEIGHT);
			tilesImage.scale = Constants.SCALE;
			
			var tilesImageOriginal:Image = new Image(Assets.TILES);
			tilesImageCountX = tilesImageOriginal.width / Assets.TILES_WIDTH;
			
			for (var x:int = 0; x < Constants.TILE_COUNT_X; x++)
			{
				for (var y:int = 0; y < Constants.TILE_COUNT_Y; y++)
				{
					if ((x != 0) && (y != 0) && (x != Constants.TILE_COUNT_X-1) && (y != Constants.TILE_COUNT_Y-1))
						continue;
					
					var tileIndex:int = 3;
					if (x == Constants.TILE_COUNT_X - 1)
					{
						tileIndex += 2;
					}
					else if (x > 0)
					{
						tileIndex += 1;
					}
						
					if (y == Constants.TILE_COUNT_Y - 1)
					{
						tileIndex += 6;
					}
					else if (y > 0)
					{
						tileIndex += 3;
					}
					
					addTile(x, y, tileIndex);
				}				
			}
			
			var distance:int = 6;
			
			var tileY:int = distance;
			
			addRow(0, 10, tileY);
			
			tileY += distance;
			
			addRow(10, 20, tileY);
			
			tileY += distance;
			
			addRow(0, 10, tileY);
			
			tileY += distance;
			
			addRow(10, 20, tileY);
			
			tileY += distance;
			
			addRow(0, 10, tileY);
			
			layer = Constants.LAYER_BACKGROUND;
		}
		
		public function addRow(xStart:int, xEnd:int, y:int):void
		{
			for (var x:int = xStart; x < xEnd; x++)
			{
				var tileIndex:int = 1;
				if (x == xStart)
				{
					tileIndex = 0;
				}
				else if (x == xEnd - 1)
				{
					tileIndex = 2;
				}
				addTile(x, y, tileIndex);
			}
		}
		
		public function addTile(tileX:int, tileY:int, tileIndex:Number):void {
			var newTile:Tile = new Tile(playState, tileX, tileY, tilesImage, tilesImageCountX, tileIndex);
			playState.add(newTile);
		}

		public override function render():void {
			super.render();
			
			//Draw.circlePlus(150, 100, 200, 0x0000FF, 1, true, 1);
			//tilemap.render(FP.buffer, new Point(tilemap.x, tilemap.y), FP.camera);
		}
	}
}