package game.states.play.data
{
	import game.playState.PlayState;

	public class LevelChunk
	{
		protected var _lineCount:int;
		protected var difficulty:int;
		protected var neededColumns:int;
		protected var levelData:Vector.<Vector.<String>>;
		
		public function LevelChunk(rawData:String, difficulty:int)
		{
			this.difficulty = difficulty;
			
			var rawLevelLines:Array = rawData.split("\n");
			
			levelData = extractLevelData(rawLevelLines);
		}
		
		protected function extractLevelData(rawLevelLines:Array):Vector.<Vector.<String>>
		{
			var result:Vector.<Vector.<String>> = new Vector.<Vector.<String>>();
			
			for each (var line:String in rawLevelLines)
			{
				var lineData:Vector.<String> = new Vector.<String>();
				for (var columnIndex:int = 0; columnIndex < line.length; columnIndex++)
				{
					var index:int = columnIndex;
					var char:String = (index < line.length) ? line.charAt(index) : " ";
					lineData.push(char);
				}
				result.push(lineData);
			}
			
			return result;
		}
		
		public function create(playState:PlayState):void
		{
		}
	}
}